Merge branch 'bp/fsmonitor' into next
[git] / git-rebase--interactive.sh
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode.  "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
4 #
5 # Copyright (c) 2006 Johannes E. Schindelin
6 #
7 # The original idea comes from Eric W. Biederman, in
8 # https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
9 #
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user.  As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
15
16 # The rebase command lines that have already been processed.  A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
20
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
24
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands.  When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it.  The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
31 #
32 # The first line of the file is of the form
33 #     # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated.  It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
39
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit.  (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
46
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be.  This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
54
55 dropped="$state_dir"/dropped
56
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
59
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
64
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file.  When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited.  When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
72
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s.  The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
79
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
82 cr=$(printf "\015")
83
84 strategy_args=${strategy:+--strategy=$strategy}
85 test -n "$strategy_opts" &&
86 eval '
87         for strategy_opt in '"$strategy_opts"'
88         do
89                 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
90         done
91 '
92
93 GIT_CHERRY_PICK_HELP="$resolvemsg"
94 export GIT_CHERRY_PICK_HELP
95
96 comment_char=$(git config --get core.commentchar 2>/dev/null)
97 case "$comment_char" in
98 '' | auto)
99         comment_char="#"
100         ;;
101 ?)
102         ;;
103 *)
104         comment_char=$(echo "$comment_char" | cut -c1)
105         ;;
106 esac
107
108 warn () {
109         printf '%s\n' "$*" >&2
110 }
111
112 # Output the commit message for the specified commit.
113 commit_message () {
114         git cat-file commit "$1" | sed "1,/^$/d"
115 }
116
117 orig_reflog_action="$GIT_REFLOG_ACTION"
118
119 comment_for_reflog () {
120         case "$orig_reflog_action" in
121         ''|rebase*)
122                 GIT_REFLOG_ACTION="rebase -i ($1)"
123                 export GIT_REFLOG_ACTION
124                 ;;
125         esac
126 }
127
128 last_count=
129 mark_action_done () {
130         sed -e 1q < "$todo" >> "$done"
131         sed -e 1d < "$todo" >> "$todo".new
132         mv -f "$todo".new "$todo"
133         new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
134         echo $new_count >"$msgnum"
135         total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
136         echo $total >"$end"
137         if test "$last_count" != "$new_count"
138         then
139                 last_count=$new_count
140                 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
141                 test -z "$verbose" || echo
142         fi
143 }
144
145 # Put the last action marked done at the beginning of the todo list
146 # again. If there has not been an action marked done yet, leave the list of
147 # items on the todo list unchanged.
148 reschedule_last_action () {
149         tail -n 1 "$done" | cat - "$todo" >"$todo".new
150         sed -e \$d <"$done" >"$done".new
151         mv -f "$todo".new "$todo"
152         mv -f "$done".new "$done"
153 }
154
155 append_todo_help () {
156         gettext "
157 Commands:
158 p, pick = use commit
159 r, reword = use commit, but edit the commit message
160 e, edit = use commit, but stop for amending
161 s, squash = use commit, but meld into previous commit
162 f, fixup = like \"squash\", but discard this commit's log message
163 x, exec = run command (the rest of the line) using shell
164 d, drop = remove commit
165
166 These lines can be re-ordered; they are executed from top to bottom.
167 " | git stripspace --comment-lines >>"$todo"
168
169         if test $(get_missing_commit_check_level) = error
170         then
171                 gettext "
172 Do not remove any line. Use 'drop' explicitly to remove a commit.
173 " | git stripspace --comment-lines >>"$todo"
174         else
175                 gettext "
176 If you remove a line here THAT COMMIT WILL BE LOST.
177 " | git stripspace --comment-lines >>"$todo"
178         fi
179 }
180
181 make_patch () {
182         sha1_and_parents="$(git rev-list --parents -1 "$1")"
183         case "$sha1_and_parents" in
184         ?*' '?*' '?*)
185                 git diff --cc $sha1_and_parents
186                 ;;
187         ?*' '?*)
188                 git diff-tree -p "$1^!"
189                 ;;
190         *)
191                 echo "Root commit"
192                 ;;
193         esac > "$state_dir"/patch
194         test -f "$msg" ||
195                 commit_message "$1" > "$msg"
196         test -f "$author_script" ||
197                 get_author_ident_from_commit "$1" > "$author_script"
198 }
199
200 die_with_patch () {
201         echo "$1" > "$state_dir"/stopped-sha
202         make_patch "$1"
203         die "$2"
204 }
205
206 exit_with_patch () {
207         echo "$1" > "$state_dir"/stopped-sha
208         make_patch $1
209         git rev-parse --verify HEAD > "$amend"
210         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
211         warn "$(eval_gettext "\
212 You can amend the commit now, with
213
214         git commit --amend \$gpg_sign_opt_quoted
215
216 Once you are satisfied with your changes, run
217
218         git rebase --continue")"
219         warn
220         exit $2
221 }
222
223 die_abort () {
224         apply_autostash
225         rm -rf "$state_dir"
226         die "$1"
227 }
228
229 has_action () {
230         test -n "$(git stripspace --strip-comments <"$1")"
231 }
232
233 is_empty_commit() {
234         tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
235                 sha1=$1
236                 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
237         }
238         ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
239                 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
240         test "$tree" = "$ptree"
241 }
242
243 is_merge_commit()
244 {
245         git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
246 }
247
248 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
249 # GIT_AUTHOR_DATE exported from the current environment.
250 do_with_author () {
251         (
252                 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
253                 "$@"
254         )
255 }
256
257 git_sequence_editor () {
258         if test -z "$GIT_SEQUENCE_EDITOR"
259         then
260                 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
261                 if [ -z "$GIT_SEQUENCE_EDITOR" ]
262                 then
263                         GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
264                 fi
265         fi
266
267         eval "$GIT_SEQUENCE_EDITOR" '"$@"'
268 }
269
270 pick_one () {
271         ff=--ff
272
273         case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
274         case "$force_rebase" in '') ;; ?*) ff= ;; esac
275         output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
276
277         if is_empty_commit "$sha1"
278         then
279                 empty_args="--allow-empty"
280         fi
281
282         test -d "$rewritten" &&
283                 pick_one_preserving_merges "$@" && return
284         output eval git cherry-pick $allow_rerere_autoupdate $allow_empty_message \
285                         ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
286                         "$strategy_args" $empty_args $ff "$@"
287
288         # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
289         # previous task so this commit is not lost.
290         ret=$?
291         case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
292         return $ret
293 }
294
295 pick_one_preserving_merges () {
296         fast_forward=t
297         case "$1" in
298         -n)
299                 fast_forward=f
300                 sha1=$2
301                 ;;
302         *)
303                 sha1=$1
304                 ;;
305         esac
306         sha1=$(git rev-parse $sha1)
307
308         if test -f "$state_dir"/current-commit
309         then
310                 if test "$fast_forward" = t
311                 then
312                         while read current_commit
313                         do
314                                 git rev-parse HEAD > "$rewritten"/$current_commit
315                         done <"$state_dir"/current-commit
316                         rm "$state_dir"/current-commit ||
317                                 die "$(gettext "Cannot write current commit's replacement sha1")"
318                 fi
319         fi
320
321         echo $sha1 >> "$state_dir"/current-commit
322
323         # rewrite parents; if none were rewritten, we can fast-forward.
324         new_parents=
325         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
326         if test "$pend" = " "
327         then
328                 pend=" root"
329         fi
330         while [ "$pend" != "" ]
331         do
332                 p=$(expr "$pend" : ' \([^ ]*\)')
333                 pend="${pend# $p}"
334
335                 if test -f "$rewritten"/$p
336                 then
337                         new_p=$(cat "$rewritten"/$p)
338
339                         # If the todo reordered commits, and our parent is marked for
340                         # rewriting, but hasn't been gotten to yet, assume the user meant to
341                         # drop it on top of the current HEAD
342                         if test -z "$new_p"
343                         then
344                                 new_p=$(git rev-parse HEAD)
345                         fi
346
347                         test $p != $new_p && fast_forward=f
348                         case "$new_parents" in
349                         *$new_p*)
350                                 ;; # do nothing; that parent is already there
351                         *)
352                                 new_parents="$new_parents $new_p"
353                                 ;;
354                         esac
355                 else
356                         if test -f "$dropped"/$p
357                         then
358                                 fast_forward=f
359                                 replacement="$(cat "$dropped"/$p)"
360                                 test -z "$replacement" && replacement=root
361                                 pend=" $replacement$pend"
362                         else
363                                 new_parents="$new_parents $p"
364                         fi
365                 fi
366         done
367         case $fast_forward in
368         t)
369                 output warn "$(eval_gettext "Fast-forward to \$sha1")"
370                 output git reset --hard $sha1 ||
371                         die "$(eval_gettext "Cannot fast-forward to \$sha1")"
372                 ;;
373         f)
374                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
375
376                 if [ "$1" != "-n" ]
377                 then
378                         # detach HEAD to current parent
379                         output git checkout $first_parent 2> /dev/null ||
380                                 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
381                 fi
382
383                 case "$new_parents" in
384                 ' '*' '*)
385                         test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
386
387                         # redo merge
388                         author_script_content=$(get_author_ident_from_commit $sha1)
389                         eval "$author_script_content"
390                         msg_content="$(commit_message $sha1)"
391                         # No point in merging the first parent, that's HEAD
392                         new_parents=${new_parents# $first_parent}
393                         merge_args="--no-log --no-ff"
394                         if ! do_with_author output eval \
395                                 git merge ${gpg_sign_opt:+$(git rev-parse \
396                                         --sq-quote "$gpg_sign_opt")} \
397                                 $allow_rerere_autoupdate "$merge_args" \
398                                 "$strategy_args" \
399                                 -m "$(git rev-parse --sq-quote "$msg_content")" \
400                                 "$new_parents"
401                         then
402                                 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
403                                 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
404                         fi
405                         echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
406                         ;;
407                 *)
408                         output eval git cherry-pick $allow_rerere_autoupdate \
409                                 $allow_empty_message \
410                                 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
411                                 "$strategy_args" "$@" ||
412                                 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
413                         ;;
414                 esac
415                 ;;
416         esac
417 }
418
419 this_nth_commit_message () {
420         n=$1
421         eval_gettext "This is the commit message #\${n}:"
422 }
423
424 skip_nth_commit_message () {
425         n=$1
426         eval_gettext "The commit message #\${n} will be skipped:"
427 }
428
429 update_squash_messages () {
430         if test -f "$squash_msg"; then
431                 mv "$squash_msg" "$squash_msg".bak || exit
432                 count=$(($(sed -n \
433                         -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
434                         -e "q" < "$squash_msg".bak)+1))
435                 {
436                         printf '%s\n' "$comment_char $(eval_ngettext \
437                                 "This is a combination of \$count commit." \
438                                 "This is a combination of \$count commits." \
439                                 $count)"
440                         sed -e 1d -e '2,/^./{
441                                 /^$/d
442                         }' <"$squash_msg".bak
443                 } >"$squash_msg"
444         else
445                 commit_message HEAD >"$fixup_msg" ||
446                 die "$(eval_gettext "Cannot write \$fixup_msg")"
447                 count=2
448                 {
449                         printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
450                         printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
451                         echo
452                         cat "$fixup_msg"
453                 } >"$squash_msg"
454         fi
455         case $1 in
456         squash)
457                 rm -f "$fixup_msg"
458                 echo
459                 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
460                 echo
461                 commit_message $2
462                 ;;
463         fixup)
464                 echo
465                 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
466                 echo
467                 # Change the space after the comment character to TAB:
468                 commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
469                 ;;
470         esac >>"$squash_msg"
471 }
472
473 peek_next_command () {
474         git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
475 }
476
477 # A squash/fixup has failed.  Prepare the long version of the squash
478 # commit message, then die_with_patch.  This code path requires the
479 # user to edit the combined commit message for all commits that have
480 # been squashed/fixedup so far.  So also erase the old squash
481 # messages, effectively causing the combined commit to be used as the
482 # new basis for any further squash/fixups.  Args: sha1 rest
483 die_failed_squash() {
484         sha1=$1
485         rest=$2
486         mv "$squash_msg" "$msg" || exit
487         rm -f "$fixup_msg"
488         cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
489         warn
490         warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
491         die_with_patch $sha1 ""
492 }
493
494 flush_rewritten_pending() {
495         test -s "$rewritten_pending" || return
496         newsha1="$(git rev-parse HEAD^0)"
497         sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
498         rm -f "$rewritten_pending"
499 }
500
501 record_in_rewritten() {
502         oldsha1="$(git rev-parse $1)"
503         echo "$oldsha1" >> "$rewritten_pending"
504
505         case "$(peek_next_command)" in
506         squash|s|fixup|f)
507                 ;;
508         *)
509                 flush_rewritten_pending
510                 ;;
511         esac
512 }
513
514 do_pick () {
515         sha1=$1
516         rest=$2
517         if test "$(git rev-parse HEAD)" = "$squash_onto"
518         then
519                 # Set the correct commit message and author info on the
520                 # sentinel root before cherry-picking the original changes
521                 # without committing (-n).  Finally, update the sentinel again
522                 # to include these changes.  If the cherry-pick results in a
523                 # conflict, this means our behaviour is similar to a standard
524                 # failed cherry-pick during rebase, with a dirty index to
525                 # resolve before manually running git commit --amend then git
526                 # rebase --continue.
527                 git commit --allow-empty --allow-empty-message --amend \
528                            --no-post-rewrite -n -q -C $sha1 &&
529                         pick_one -n $sha1 &&
530                         git commit --allow-empty --allow-empty-message \
531                                    --amend --no-post-rewrite -n -q -C $sha1 \
532                                    ${gpg_sign_opt:+"$gpg_sign_opt"} ||
533                                    die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
534         else
535                 pick_one $sha1 ||
536                         die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
537         fi
538 }
539
540 do_next () {
541         rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
542         read -r command sha1 rest < "$todo"
543         case "$command" in
544         "$comment_char"*|''|noop|drop|d)
545                 mark_action_done
546                 ;;
547         "$cr")
548                 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
549                 mark_action_done
550                 ;;
551         pick|p)
552                 comment_for_reflog pick
553
554                 mark_action_done
555                 do_pick $sha1 "$rest"
556                 record_in_rewritten $sha1
557                 ;;
558         reword|r)
559                 comment_for_reflog reword
560
561                 mark_action_done
562                 do_pick $sha1 "$rest"
563                 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} \
564                         $allow_empty_message || {
565                         warn "$(eval_gettext "\
566 Could not amend commit after successfully picking \$sha1... \$rest
567 This is most likely due to an empty commit message, or the pre-commit hook
568 failed. If the pre-commit hook failed, you may need to resolve the issue before
569 you are able to reword the commit.")"
570                         exit_with_patch $sha1 1
571                 }
572                 record_in_rewritten $sha1
573                 ;;
574         edit|e)
575                 comment_for_reflog edit
576
577                 mark_action_done
578                 do_pick $sha1 "$rest"
579                 sha1_abbrev=$(git rev-parse --short $sha1)
580                 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
581                 exit_with_patch $sha1 0
582                 ;;
583         squash|s|fixup|f)
584                 case "$command" in
585                 squash|s)
586                         squash_style=squash
587                         ;;
588                 fixup|f)
589                         squash_style=fixup
590                         ;;
591                 esac
592                 comment_for_reflog $squash_style
593
594                 test -f "$done" && has_action "$done" ||
595                         die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
596
597                 mark_action_done
598                 update_squash_messages $squash_style $sha1
599                 author_script_content=$(get_author_ident_from_commit HEAD)
600                 echo "$author_script_content" > "$author_script"
601                 eval "$author_script_content"
602                 if ! pick_one -n $sha1
603                 then
604                         git rev-parse --verify HEAD >"$amend"
605                         die_failed_squash $sha1 "$rest"
606                 fi
607                 case "$(peek_next_command)" in
608                 squash|s|fixup|f)
609                         # This is an intermediate commit; its message will only be
610                         # used in case of trouble.  So use the long version:
611                         do_with_author output git commit --amend --no-verify -F "$squash_msg" \
612                                 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
613                                 die_failed_squash $sha1 "$rest"
614                         ;;
615                 *)
616                         # This is the final command of this squash/fixup group
617                         if test -f "$fixup_msg"
618                         then
619                                 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
620                                         ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
621                                         die_failed_squash $sha1 "$rest"
622                         else
623                                 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
624                                 rm -f "$GIT_DIR"/MERGE_MSG
625                                 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
626                                         ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
627                                         die_failed_squash $sha1 "$rest"
628                         fi
629                         rm -f "$squash_msg" "$fixup_msg"
630                         ;;
631                 esac
632                 record_in_rewritten $sha1
633                 ;;
634         x|"exec")
635                 read -r command rest < "$todo"
636                 mark_action_done
637                 eval_gettextln "Executing: \$rest"
638                 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
639                 status=$?
640                 # Run in subshell because require_clean_work_tree can die.
641                 dirty=f
642                 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
643                 if test "$status" -ne 0
644                 then
645                         warn "$(eval_gettext "Execution failed: \$rest")"
646                         test "$dirty" = f ||
647                                 warn "$(gettext "and made changes to the index and/or the working tree")"
648
649                         warn "$(gettext "\
650 You can fix the problem, and then run
651
652         git rebase --continue")"
653                         warn
654                         if test $status -eq 127         # command not found
655                         then
656                                 status=1
657                         fi
658                         exit "$status"
659                 elif test "$dirty" = t
660                 then
661                         # TRANSLATORS: after these lines is a command to be issued by the user
662                         warn "$(eval_gettext "\
663 Execution succeeded: \$rest
664 but left changes to the index and/or the working tree
665 Commit or stash your changes, and then run
666
667         git rebase --continue")"
668                         warn
669                         exit 1
670                 fi
671                 ;;
672         *)
673                 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
674                 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
675                 if git rev-parse --verify -q "$sha1" >/dev/null
676                 then
677                         die_with_patch $sha1 "$fixtodo"
678                 else
679                         die "$fixtodo"
680                 fi
681                 ;;
682         esac
683         test -s "$todo" && return
684
685         comment_for_reflog finish &&
686         newhead=$(git rev-parse HEAD) &&
687         case $head_name in
688         refs/*)
689                 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
690                 git update-ref -m "$message" $head_name $newhead $orig_head &&
691                 git symbolic-ref \
692                   -m "$GIT_REFLOG_ACTION: returning to $head_name" \
693                   HEAD $head_name
694                 ;;
695         esac && {
696                 test ! -f "$state_dir"/verbose ||
697                         git diff-tree --stat $orig_head..HEAD
698         } &&
699         {
700                 test -s "$rewritten_list" &&
701                 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
702                 true # we don't care if this copying failed
703         } &&
704         hook="$(git rev-parse --git-path hooks/post-rewrite)"
705         if test -x "$hook" && test -s "$rewritten_list"; then
706                 "$hook" rebase < "$rewritten_list"
707                 true # we don't care if this hook failed
708         fi &&
709                 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
710
711         return 1 # not failure; just to break the do_rest loop
712 }
713
714 # can only return 0, when the infinite loop breaks
715 do_rest () {
716         while :
717         do
718                 do_next || break
719         done
720 }
721
722 expand_todo_ids() {
723         git rebase--helper --expand-ids
724 }
725
726 collapse_todo_ids() {
727         git rebase--helper --shorten-ids
728 }
729
730 # Switch to the branch in $into and notify it in the reflog
731 checkout_onto () {
732         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
733         output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
734         git update-ref ORIG_HEAD $orig_head
735 }
736
737 get_missing_commit_check_level () {
738         check_level=$(git config --get rebase.missingCommitsCheck)
739         check_level=${check_level:-ignore}
740         # Don't be case sensitive
741         printf '%s' "$check_level" | tr 'A-Z' 'a-z'
742 }
743
744 # The whole contents of this file is run by dot-sourcing it from
745 # inside a shell function.  It used to be that "return"s we see
746 # below were not inside any function, and expected to return
747 # to the function that dot-sourced us.
748 #
749 # However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
750 # construct and continue to run the statements that follow such a "return".
751 # As a work-around, we introduce an extra layer of a function
752 # here, and immediately call it after defining it.
753 git_rebase__interactive () {
754
755 case "$action" in
756 continue)
757         if test ! -d "$rewritten"
758         then
759                 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
760                         --continue
761         fi
762         # do we have anything to commit?
763         if git diff-index --cached --quiet HEAD --
764         then
765                 # Nothing to commit -- skip this commit
766
767                 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
768                 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
769                 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
770         else
771                 if ! test -f "$author_script"
772                 then
773                         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
774                         die "$(eval_gettext "\
775 You have staged changes in your working tree.
776 If these changes are meant to be
777 squashed into the previous commit, run:
778
779   git commit --amend \$gpg_sign_opt_quoted
780
781 If they are meant to go into a new commit, run:
782
783   git commit \$gpg_sign_opt_quoted
784
785 In both cases, once you're done, continue with:
786
787   git rebase --continue
788 ")"
789                 fi
790                 . "$author_script" ||
791                         die "$(gettext "Error trying to find the author identity to amend commit")"
792                 if test -f "$amend"
793                 then
794                         current_head=$(git rev-parse --verify HEAD)
795                         test "$current_head" = $(cat "$amend") ||
796                         die "$(gettext "\
797 You have uncommitted changes in your working tree. Please commit them
798 first and then run 'git rebase --continue' again.")"
799                         do_with_author git commit --amend --no-verify -F "$msg" -e \
800                                 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
801                                 die "$(gettext "Could not commit staged changes.")"
802                 else
803                         do_with_author git commit --no-verify -F "$msg" -e \
804                                 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
805                                 die "$(gettext "Could not commit staged changes.")"
806                 fi
807         fi
808
809         if test -r "$state_dir"/stopped-sha
810         then
811                 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
812         fi
813
814         require_clean_work_tree "rebase"
815         do_rest
816         return 0
817         ;;
818 skip)
819         git rerere clear
820
821         if test ! -d "$rewritten"
822         then
823                 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
824                         --continue
825         fi
826         do_rest
827         return 0
828         ;;
829 edit-todo)
830         git stripspace --strip-comments <"$todo" >"$todo".new
831         mv -f "$todo".new "$todo"
832         collapse_todo_ids
833         append_todo_help
834         gettext "
835 You are editing the todo file of an ongoing interactive rebase.
836 To continue rebase after editing, run:
837     git rebase --continue
838
839 " | git stripspace --comment-lines >>"$todo"
840
841         git_sequence_editor "$todo" ||
842                 die "$(gettext "Could not execute editor")"
843         expand_todo_ids
844
845         exit
846         ;;
847 esac
848
849 comment_for_reflog start
850
851 if test ! -z "$switch_to"
852 then
853         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
854         output git checkout "$switch_to" -- ||
855                 die "$(eval_gettext "Could not checkout \$switch_to")"
856
857         comment_for_reflog start
858 fi
859
860 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
861 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
862
863 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
864 write_basic_state
865 if test t = "$preserve_merges"
866 then
867         if test -z "$rebase_root"
868         then
869                 mkdir "$rewritten" &&
870                 for c in $(git merge-base --all $orig_head $upstream)
871                 do
872                         echo $onto > "$rewritten"/$c ||
873                                 die "$(gettext "Could not init rewritten commits")"
874                 done
875         else
876                 mkdir "$rewritten" &&
877                 echo $onto > "$rewritten"/root ||
878                         die "$(gettext "Could not init rewritten commits")"
879         fi
880         # No cherry-pick because our first pass is to determine
881         # parents to rewrite and skipping dropped commits would
882         # prematurely end our probe
883         merges_option=
884 else
885         merges_option="--no-merges --cherry-pick"
886 fi
887
888 shorthead=$(git rev-parse --short $orig_head)
889 shortonto=$(git rev-parse --short $onto)
890 if test -z "$rebase_root"
891         # this is now equivalent to ! -z "$upstream"
892 then
893         shortupstream=$(git rev-parse --short $upstream)
894         revisions=$upstream...$orig_head
895         shortrevisions=$shortupstream..$shorthead
896 else
897         revisions=$onto...$orig_head
898         shortrevisions=$shorthead
899 fi
900 if test t != "$preserve_merges"
901 then
902         git rebase--helper --make-script ${keep_empty:+--keep-empty} \
903                 $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
904         die "$(gettext "Could not generate todo list")"
905 else
906         format=$(git config --get rebase.instructionFormat)
907         # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
908         git rev-list $merges_option --format="%m%H ${format:-%s}" \
909                 --reverse --left-right --topo-order \
910                 $revisions ${restrict_revision+^$restrict_revision} | \
911                 sed -n "s/^>//p" |
912         while read -r sha1 rest
913         do
914
915                 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
916                 then
917                         comment_out="$comment_char "
918                 else
919                         comment_out=
920                 fi
921
922                 if test -z "$rebase_root"
923                 then
924                         preserve=t
925                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
926                         do
927                                 if test -f "$rewritten"/$p
928                                 then
929                                         preserve=f
930                                 fi
931                         done
932                 else
933                         preserve=f
934                 fi
935                 if test f = "$preserve"
936                 then
937                         touch "$rewritten"/$sha1
938                         printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
939                 fi
940         done
941 fi
942
943 # Watch for commits that been dropped by --cherry-pick
944 if test t = "$preserve_merges"
945 then
946         mkdir "$dropped"
947         # Save all non-cherry-picked changes
948         git rev-list $revisions --left-right --cherry-pick | \
949                 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
950         # Now all commits and note which ones are missing in
951         # not-cherry-picks and hence being dropped
952         git rev-list $revisions |
953         while read rev
954         do
955                 if test -f "$rewritten"/$rev &&
956                    ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
957                 then
958                         # Use -f2 because if rev-list is telling us this commit is
959                         # not worthwhile, we don't want to track its multiple heads,
960                         # just the history of its first-parent for others that will
961                         # be rebasing on top of it
962                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
963                         sha1=$(git rev-list -1 $rev)
964                         sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
965                         rm "$rewritten"/$rev
966                 fi
967         done
968 fi
969
970 test -s "$todo" || echo noop >> "$todo"
971 test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
972 test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
973
974 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
975 todocount=${todocount##* }
976
977 cat >>"$todo" <<EOF
978
979 $comment_char $(eval_ngettext \
980         "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
981         "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
982         "$todocount")
983 EOF
984 append_todo_help
985 gettext "
986 However, if you remove everything, the rebase will be aborted.
987
988 " | git stripspace --comment-lines >>"$todo"
989
990 if test -z "$keep_empty"
991 then
992         printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
993 fi
994
995
996 has_action "$todo" ||
997         return 2
998
999 cp "$todo" "$todo".backup
1000 collapse_todo_ids
1001 git_sequence_editor "$todo" ||
1002         die_abort "$(gettext "Could not execute editor")"
1003
1004 has_action "$todo" ||
1005         return 2
1006
1007 git rebase--helper --check-todo-list || {
1008         ret=$?
1009         checkout_onto
1010         exit $ret
1011 }
1012
1013 expand_todo_ids
1014
1015 test -d "$rewritten" || test -n "$force_rebase" ||
1016 onto="$(git rebase--helper --skip-unnecessary-picks)" ||
1017 die "Could not skip unnecessary pick commands"
1018
1019 checkout_onto
1020 if test -z "$rebase_root" && test ! -d "$rewritten"
1021 then
1022         require_clean_work_tree "rebase"
1023         exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
1024                 --continue
1025 fi
1026 do_rest
1027
1028 }
1029 # ... and then we call the whole thing.
1030 git_rebase__interactive